From 967ec5e6b1d49aef586a2ea68f669ccbfecd10df Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Jan 03 2021 07:56:00 +0000
Subject: [PATCH 2027/2232] Merge pull request #653 from dtolnay/lifetimes


Enable lifetimes on opaque Rust types
---

diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index 11115b8..476012f 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -677,11 +677,12 @@ fn expand_rust_type_import(ety: &ExternType) -> TokenStream {
 
 fn expand_rust_type_impl(ety: &ExternType) -> TokenStream {
     let ident = &ety.name.rust;
+    let generics = &ety.generics;
     let span = ident.span();
     let unsafe_impl = quote_spanned!(ety.type_token.span=> unsafe impl);
 
     let mut impls = quote_spanned! {span=>
-        #unsafe_impl ::cxx::private::RustType for #ident {}
+        #unsafe_impl #generics ::cxx::private::RustType for #ident #generics {}
     };
 
     for derive in &ety.derives {
@@ -689,7 +690,7 @@ fn expand_rust_type_impl(ety: &ExternType) -> TokenStream {
             let type_id = type_id(&ety.name);
             let span = derive.span;
             impls.extend(quote_spanned! {span=>
-                unsafe impl ::cxx::ExternType for #ident {
+                unsafe impl #generics ::cxx::ExternType for #ident #generics {
                     type Id = #type_id;
                     type Kind = ::cxx::kind::Opaque;
                 }
diff --git a/syntax/check.rs b/syntax/check.rs
index 9a8881f..b9f6660 100644
--- a/syntax/check.rs
+++ b/syntax/check.rs
@@ -335,13 +335,6 @@ fn check_api_type(cx: &mut Check, ety: &ExternType) {
         cx.error(derive, msg);
     }
 
-    if let Some(lifetime) = ety.generics.lifetimes.first() {
-        if ety.lang == Lang::Rust {
-            let msg = "extern Rust type with lifetimes is not supported yet";
-            cx.error(lifetime, msg);
-        }
-    }
-
     if !ety.bounds.is_empty() {
         let bounds = &ety.bounds;
         let span = quote!(#(#bounds)*);
diff --git a/tests/ffi/lib.rs b/tests/ffi/lib.rs
index ba28f50..5ac461c 100644
--- a/tests/ffi/lib.rs
+++ b/tests/ffi/lib.rs
@@ -210,6 +210,11 @@ pub mod ffi {
         type Job = crate::module::ffi::Job;
     }
 
+    extern "Rust" {
+        #[derive(ExternType)]
+        type Reference<'a>;
+    }
+
     unsafe extern "C++" {
         type Borrow<'a>;
 
@@ -377,6 +382,8 @@ impl R {
     }
 }
 
+pub struct Reference<'a>(&'a String);
+
 impl ffi::Shared {
     fn r_method_on_shared(&self) -> String {
         "2020".to_owned()

